diff --git a/app/src/main/java/org/mian/gitnex/database/api/UserAccountsApi.java b/app/src/main/java/org/mian/gitnex/database/api/UserAccountsApi.java
index 482da27b..80b5d920 100644
--- a/app/src/main/java/org/mian/gitnex/database/api/UserAccountsApi.java
+++ b/app/src/main/java/org/mian/gitnex/database/api/UserAccountsApi.java
@@ -1,34 +1,25 @@
 package org.mian.gitnex.database.api;
 
 import android.content.Context;
-import android.util.Log;
 import androidx.lifecycle.LiveData;
 import org.mian.gitnex.database.dao.UserAccountsDao;
-import org.mian.gitnex.database.db.GitnexDatabase;
 import org.mian.gitnex.database.models.UserAccount;
-import org.mian.gitnex.helpers.Constants;
 import java.util.List;
 
 /**
  * Author M M Arif
  */
 
-public class UserAccountsApi {
+public class UserAccountsApi extends BaseApi {
 
-	private static UserAccountsDao userAccountsDao;
-	private static UserAccount userAccount;
-	private static List<UserAccount> userAccounts;
-	private static Integer checkAccount;
-	private static long accountId;
+	private final UserAccountsDao userAccountsDao;
 
-	public UserAccountsApi(Context context) {
-
-		GitnexDatabase db;
-		db = GitnexDatabase.getDatabaseInstance(context);
-		userAccountsDao = db.userAccountsDao();
+	UserAccountsApi(Context context) {
+		super(context);
+		userAccountsDao = gitnexDatabase.userAccountsDao();
 	}
 
-	public long insertNewAccount(String accountName, String instanceUrl, String userName, String token, String serverVersion) {
+	public long createNewAccount(String accountName, String instanceUrl, String userName, String token, String serverVersion) {
 
 		UserAccount userAccount = new UserAccount();
 		userAccount.setAccountName(accountName);
@@ -37,96 +28,48 @@ public class UserAccountsApi {
 		userAccount.setToken(token);
 		userAccount.setServerVersion(serverVersion);
 
-		return insertNewAccountAsync(userAccount);
+		return userAccountsDao.createAccount(userAccount);
+
 	}
 
-	private static long insertNewAccountAsync(final UserAccount userAccount) {
-
-		try {
-
-			Thread thread = new Thread(() -> accountId = userAccountsDao.newAccount(userAccount));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.userAccountsApi, e.toString());
-		}
-
-		return accountId;
-	}
-
-	public static void updateServerVersion(final String serverVersion, final int accountId) {
-
-		new Thread(() -> userAccountsDao.updateServerVersion(serverVersion, accountId)).start();
+	public void updateServerVersion(final String serverVersion, final int accountId) {
+		executorService.execute(() -> userAccountsDao.updateServerVersion(serverVersion, accountId));
 	}
 
 	public void updateToken(final int accountId, final String token) {
-
-		new Thread(() -> userAccountsDao.updateAccountToken(accountId, token)).start();
+		executorService.execute(() -> userAccountsDao.updateAccountToken(accountId, token));
 	}
 
 	public void updateTokenByAccountName(final String accountName, final String token) {
-
-		new Thread(() -> userAccountsDao.updateAccountTokenByAccountName(accountName, token)).start();
+		executorService.execute(() -> userAccountsDao.updateAccountTokenByAccountName(accountName, token));
 	}
 
-	public UserAccount getAccountData(String accountName) {
-
-		try {
-
-			Thread thread = new Thread(() -> userAccount = userAccountsDao.fetchRowByAccount_(accountName));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.userAccountsApi, e.toString());
-		}
-
-		return userAccount;
+	public UserAccount getAccountByName(String accountName) {
+		return userAccountsDao.getAccountByName(accountName);
 	}
 
-	public Integer getCount(String accountName) {
+	public UserAccount getAccountById(int accountId) {
+		return userAccountsDao.getAccountById(accountId);
+	}
 
-		try {
+	public Integer getCount() {
+		return userAccountsDao.getCount();
+	}
 
-			Thread thread = new Thread(() -> checkAccount = userAccountsDao.getCount(accountName));
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.userAccountsApi, e.toString());
-		}
-
-		return checkAccount;
+	public Boolean userAccountExists(String accountName) {
+		return userAccountsDao.userAccountExists(accountName);
 	}
 
 	public LiveData<List<UserAccount>> getAllAccounts() {
-
-		return userAccountsDao.fetchAllAccounts();
+		return userAccountsDao.getAllAccounts();
 	}
 
 	public List<UserAccount> usersAccounts() {
-
-		try {
-
-			Thread thread = new Thread(() -> userAccounts = userAccountsDao.userAccounts());
-			thread.start();
-			thread.join();
-		}
-		catch(InterruptedException e) {
-
-			Log.e(Constants.userAccountsApi, e.toString());
-		}
-
-		return userAccounts;
+		return userAccountsDao.userAccounts();
 	}
 
 	public void deleteAccount(final int accountId) {
-
-		new Thread(() -> userAccountsDao.deleteAccount(accountId)).start();
+		executorService.execute(() -> userAccountsDao.deleteAccount(accountId));
 	}
 
 }
diff --git a/app/src/main/java/org/mian/gitnex/database/dao/UserAccountsDao.java b/app/src/main/java/org/mian/gitnex/database/dao/UserAccountsDao.java
index 9abad2db..fd1e249b 100644
--- a/app/src/main/java/org/mian/gitnex/database/dao/UserAccountsDao.java
+++ b/app/src/main/java/org/mian/gitnex/database/dao/UserAccountsDao.java
@@ -15,22 +15,25 @@ import java.util.List;
 public interface UserAccountsDao {
 
     @Insert
-    long newAccount(UserAccount userAccounts);
+    long createAccount(UserAccount userAccounts);
 
     @Query("SELECT * FROM UserAccounts ORDER BY accountId ASC")
-    LiveData<List<UserAccount>> fetchAllAccounts();
+    LiveData<List<UserAccount>> getAllAccounts();
 
 	@Query("SELECT * FROM UserAccounts ORDER BY accountId ASC")
 	List<UserAccount> userAccounts();
 
-    @Query("SELECT COUNT(accountId) FROM UserAccounts WHERE accountName = :accountName")
-    Integer getCount(String accountName);
+    @Query("SELECT COUNT(accountId) FROM UserAccounts")
+    Integer getCount();
 
-    @Query("SELECT * FROM UserAccounts WHERE accountName = :accountName")
-    UserAccount fetchRowByAccount_(String accountName);
+    @Query("SELECT COUNT(accountId) FROM UserAccounts WHERE accountName = :accountName LIMIT 1")
+    Boolean userAccountExists(String accountName);
 
-    @Query("SELECT * FROM UserAccounts WHERE accountId = :accountId")
-    UserAccount fetchRowByAccountId(int accountId);
+    @Query("SELECT * FROM UserAccounts WHERE accountName = :accountName LIMIT 1")
+    UserAccount getAccountByName(String accountName);
+
+    @Query("SELECT * FROM UserAccounts WHERE accountId = :accountId LIMIT 1")
+    UserAccount getAccountById(int accountId);
 
     @Query("UPDATE UserAccounts SET serverVersion = :serverVersion WHERE accountId = :accountId")
     void updateServerVersion(String serverVersion, int accountId);
diff --git a/app/src/main/java/org/mian/gitnex/database/db/GitnexDatabase.java b/app/src/main/java/org/mian/gitnex/database/db/GitnexDatabase.java
index 3669d8ea..b0fa21ac 100644
--- a/app/src/main/java/org/mian/gitnex/database/db/GitnexDatabase.java
+++ b/app/src/main/java/org/mian/gitnex/database/db/GitnexDatabase.java
@@ -22,32 +22,16 @@ import org.mian.gitnex.database.models.UserAccount;
         version = 3, exportSchema = false)
 public abstract class GitnexDatabase extends RoomDatabase {
 
+	private static final String DB_NAME = "gitnex";
     private static GitnexDatabase gitnexDatabase;
 
-    public static GitnexDatabase getDatabaseInstance(Context context) {
-
-        if (gitnexDatabase == null) {
-
-            String DB_NAME = "gitnex";
-            gitnexDatabase = Room.databaseBuilder(context, GitnexDatabase.class, DB_NAME)
-                    //.fallbackToDestructiveMigration()
-                    .addMigrations(MIGRATION_1_2, MIGRATION_2_3)
-                    .build();
-        }
-
-        return gitnexDatabase;
-    }
-
     public abstract DraftsDao draftsDao();
-
     public abstract RepositoriesDao repositoriesDao();
-
     public abstract UserAccountsDao userAccountsDao();
 
     private static final Migration MIGRATION_1_2 = new Migration(1, 2) {
         @Override
         public void migrate(@NonNull SupportSQLiteDatabase database) {
-
             //database.execSQL("DROP TABLE Drafts");
 	        database.execSQL("ALTER TABLE 'Drafts' ADD COLUMN 'commentId' TEXT");
         }
@@ -56,8 +40,27 @@ public abstract class GitnexDatabase extends RoomDatabase {
 	private static final Migration MIGRATION_2_3 = new Migration(2, 3) {
 		@Override
 		public void migrate(@NonNull SupportSQLiteDatabase database) {
-
 			database.execSQL("ALTER TABLE 'Drafts' ADD COLUMN 'issueType' TEXT");
 		}
 	};
+
+	public static GitnexDatabase getDatabaseInstance(Context context) {
+
+		if (gitnexDatabase == null) {
+			synchronized(GitnexDatabase.class) {
+				if(gitnexDatabase == null) {
+
+					gitnexDatabase = Room.databaseBuilder(context, GitnexDatabase.class, DB_NAME)
+						// .fallbackToDestructiveMigration()
+						.allowMainThreadQueries()
+						.addMigrations(MIGRATION_1_2, MIGRATION_2_3)
+						.build();
+
+				}
+			}
+		}
+
+		return gitnexDatabase;
+
+	}
 }
diff --git a/app/src/main/java/org/mian/gitnex/fragments/BottomSheetReplyFragment.java b/app/src/main/java/org/mian/gitnex/fragments/BottomSheetReplyFragment.java
index 851075dd..7fc9a84a 100644
--- a/app/src/main/java/org/mian/gitnex/fragments/BottomSheetReplyFragment.java
+++ b/app/src/main/java/org/mian/gitnex/fragments/BottomSheetReplyFragment.java
@@ -24,6 +24,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.actions.ActionResult;
 import org.mian.gitnex.actions.IssueActions;
 import org.mian.gitnex.activities.MainActivity;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.DraftsApi;
 import org.mian.gitnex.databinding.BottomSheetReplyLayoutBinding;
 import org.mian.gitnex.helpers.Constants;
@@ -57,7 +58,7 @@ public class BottomSheetReplyFragment extends BottomSheetDialogFragment {
 		super.onAttach(context);
 
 		tinyDB = TinyDB.getInstance(context);
-		draftsApi = new DraftsApi(context);
+		draftsApi = BaseApi.getInstance(context, DraftsApi.class);
 
 		repositoryId = (int) tinyDB.getLong("repositoryId", 0);
 		currentActiveAccountId = tinyDB.getInt("currentActiveAccountId");
@@ -281,7 +282,7 @@ public class BottomSheetReplyFragment extends BottomSheetDialogFragment {
 			}
 			else {
 
-				DraftsApi.updateDraft(text, (int) draftId, "TODO");
+				draftsApi.updateDraft(text, (int) draftId, "TODO");
 			}
 
 			draftsHint.setVisibility(View.VISIBLE);
diff --git a/app/src/main/java/org/mian/gitnex/fragments/DraftsFragment.java b/app/src/main/java/org/mian/gitnex/fragments/DraftsFragment.java
index 6a63f49f..f53f6d1e 100644
--- a/app/src/main/java/org/mian/gitnex/fragments/DraftsFragment.java
+++ b/app/src/main/java/org/mian/gitnex/fragments/DraftsFragment.java
@@ -22,6 +22,7 @@ import androidx.swiperefreshlayout.widget.SwipeRefreshLayout;
 import org.mian.gitnex.R;
 import org.mian.gitnex.activities.MainActivity;
 import org.mian.gitnex.adapters.DraftsAdapter;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.DraftsApi;
 import org.mian.gitnex.database.models.DraftWithRepository;
 import org.mian.gitnex.databinding.FragmentDraftsBinding;
@@ -59,7 +60,7 @@ public class DraftsFragment extends Fragment {
         TinyDB tinyDb = TinyDB.getInstance(ctx);
 
 	    draftsList_ = new ArrayList<>();
-        draftsApi = new DraftsApi(ctx);
+        draftsApi = BaseApi.getInstance(ctx, DraftsApi.class);
 
         noData = fragmentDraftsBinding.noData;
         mRecyclerView = fragmentDraftsBinding.recyclerView;
@@ -123,7 +124,7 @@ public class DraftsFragment extends Fragment {
 
     	if(draftsList_.size() > 0) {
 
-		    DraftsApi.deleteAllDrafts(accountId);
+		    BaseApi.getInstance(ctx, DraftsApi.class).deleteAllDrafts(accountId);
 		    draftsList_.clear();
 		    adapter.notifyDataSetChanged();
 		    Toasty.success(ctx, getResources().getString(R.string.draftsDeleteSuccess));
diff --git a/app/src/main/java/org/mian/gitnex/fragments/RepositoriesFragment.java b/app/src/main/java/org/mian/gitnex/fragments/RepositoriesFragment.java
index d1eb44e5..7cf70021 100644
--- a/app/src/main/java/org/mian/gitnex/fragments/RepositoriesFragment.java
+++ b/app/src/main/java/org/mian/gitnex/fragments/RepositoriesFragment.java
@@ -63,8 +63,7 @@ public class RepositoriesFragment extends Fragment {
         mRecyclerView.setHasFixedSize(true);
         mRecyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
 
-        DividerItemDecoration dividerItemDecoration = new DividerItemDecoration(mRecyclerView.getContext(),
-                DividerItemDecoration.VERTICAL);
+        DividerItemDecoration dividerItemDecoration = new DividerItemDecoration(mRecyclerView.getContext(), DividerItemDecoration.VERTICAL);
         mRecyclerView.addItemDecoration(dividerItemDecoration);
 
         createNewRepo = fragmentRepositoriesBinding.addNewRepo;
diff --git a/app/src/main/java/org/mian/gitnex/fragments/UserAccountsFragment.java b/app/src/main/java/org/mian/gitnex/fragments/UserAccountsFragment.java
index b83985b0..4f13a352 100644
--- a/app/src/main/java/org/mian/gitnex/fragments/UserAccountsFragment.java
+++ b/app/src/main/java/org/mian/gitnex/fragments/UserAccountsFragment.java
@@ -18,6 +18,7 @@ import org.mian.gitnex.R;
 import org.mian.gitnex.activities.AddNewAccountActivity;
 import org.mian.gitnex.activities.MainActivity;
 import org.mian.gitnex.adapters.UserAccountsAdapter;
+import org.mian.gitnex.database.api.BaseApi;
 import org.mian.gitnex.database.api.UserAccountsApi;
 import org.mian.gitnex.database.models.UserAccount;
 import org.mian.gitnex.databinding.FragmentUserAccountsBinding;
@@ -48,7 +49,7 @@ public class UserAccountsFragment extends Fragment {
 		((MainActivity) requireActivity()).setActionBarTitle(getResources().getString(R.string.pageTitleUserAccounts));
 
 		userAccountsList = new ArrayList<>();
-		userAccountsApi = new UserAccountsApi(ctx);
+		userAccountsApi = BaseApi.getInstance(ctx, UserAccountsApi.class);
 
 		mRecyclerView = fragmentUserAccountsBinding.recyclerView;
 		final SwipeRefreshLayout swipeRefresh = fragmentUserAccountsBinding.pullToRefresh;
diff --git a/app/src/main/java/org/mian/gitnex/helpers/AppUtil.java b/app/src/main/java/org/mian/gitnex/helpers/AppUtil.java
index 0a539feb..c714b294 100644
--- a/app/src/main/java/org/mian/gitnex/helpers/AppUtil.java
+++ b/app/src/main/java/org/mian/gitnex/helpers/AppUtil.java
@@ -13,6 +13,7 @@ import android.util.TypedValue;
 import android.view.View;
 import androidx.annotation.ColorInt;
 import androidx.core.content.pm.PackageInfoCompat;
+import org.mian.gitnex.database.models.UserAccount;
 import java.io.IOException;
 import java.io.InputStream;
 import java.io.OutputStream;
@@ -69,7 +70,6 @@ public class AppUtil {
 	}
 
 	public static boolean hasNetworkConnection(Context context) {
-
 		return NetworkStatusObserver.getInstance(context).hasNetworkConnection();
 	}
 
@@ -274,32 +274,27 @@ public class AppUtil {
 	}
 
 	public static String getLastCharactersOfWord(String str, int count) {
-
 		return str.substring(str.length() - count);
 
 	}
 
 	public static void setMultiVisibility(int visibility, View... views) {
-
 		for(View view : views) {
-
 			view.setVisibility(visibility);
 		}
 	}
 
 	public static int getPixelsFromDensity(Context context, int dp) {
-
 		return (int) (context.getResources().getDisplayMetrics().density * dp);
 	}
 
 	public static int getPixelsFromScaledDensity(Context context, int sp) {
-
 		return (int) (context.getResources().getDisplayMetrics().scaledDensity * sp);
 	}
 
-	public static int getLineCount(String s) {
+	public static long getLineCount(String s) {
 
-		int lines = 0;
+		long lines = 0;
 
 		Pattern pattern = Pattern.compile("(\r\n|\r|\n)");
 		Matcher matcher = pattern.matcher(s);
@@ -307,6 +302,11 @@ public class AppUtil {
 		while(matcher.find())
 			lines++;
 
+		// Sometimes there may be text, but no line breaks.
+		// This should still count as one line.
+		if(s.length() > 0 && lines == 0)
+			return 1;
+
 		return lines;
 
 	}
@@ -320,5 +320,27 @@ public class AppUtil {
 		clipboard.setPrimaryClip(clip);
 
 		Toasty.info(ctx, message);
+
 	}
+
+	public static boolean switchToAccount(Context context, UserAccount userAccount) {
+
+		TinyDB tinyDB = TinyDB.getInstance(context);
+
+		if(tinyDB.getInt("currentActiveAccountId") != userAccount.getAccountId()) {
+
+			tinyDB.putString("loginUid", userAccount.getUserName());
+			tinyDB.putString("userLogin", userAccount.getUserName());
+			tinyDB.putString(userAccount.getUserName() + "-token", userAccount.getToken());
+			tinyDB.putString("instanceUrl", userAccount.getInstanceUrl());
+			tinyDB.putInt("currentActiveAccountId", userAccount.getAccountId());
+
+			return true;
+
+		}
+
+		return false;
+
+	}
+
 }
diff --git a/app/src/main/java/org/mian/gitnex/helpers/Authorization.java b/app/src/main/java/org/mian/gitnex/helpers/Authorization.java
index e97dd246..30cf1126 100644
--- a/app/src/main/java/org/mian/gitnex/helpers/Authorization.java
+++ b/app/src/main/java/org/mian/gitnex/helpers/Authorization.java
@@ -1,6 +1,7 @@
 package org.mian.gitnex.helpers;
 
 import android.content.Context;
+import org.mian.gitnex.database.models.UserAccount;
 import okhttp3.Credentials;
 
 /**
@@ -24,11 +25,14 @@ public class Authorization {
 
 	}
 
+	public static String get(UserAccount userAccount) {
+		return "token " + userAccount.getToken();
+	}
+
 	public static String getWeb(Context context) {
 
 		TinyDB tinyDb = TinyDB.getInstance(context);
 		return Credentials.basic("", tinyDb.getString(tinyDb.getString("loginUid") + "-token"));
-
 	}
 
 }
diff --git a/app/src/main/java/org/mian/gitnex/helpers/Constants.java b/app/src/main/java/org/mian/gitnex/helpers/Constants.java
index ddb0e23b..c9683935 100644
--- a/app/src/main/java/org/mian/gitnex/helpers/Constants.java
+++ b/app/src/main/java/org/mian/gitnex/helpers/Constants.java
@@ -56,6 +56,11 @@ public class Constants {
 	public static final String mainNotificationChannelId = "main_channel";
 	public static final String downloadNotificationChannelId = "dl_channel";
 
+	public static final long[] defaultVibrationPattern = new long[] { 1000, 1000 };
+
 	public static final String[] fallbackReactions = new String[]{"+1", "-1", "laugh", "hooray", "confused", "heart", "rocket", "eyes"};
 
+	// work managers
+	public static final String notificationsWorkerId  = "notifications_worker";
+
 }
diff --git a/app/src/main/java/org/mian/gitnex/helpers/Version.java b/app/src/main/java/org/mian/gitnex/helpers/Version.java
index 50bc6c4c..a6b1da91 100644
--- a/app/src/main/java/org/mian/gitnex/helpers/Version.java
+++ b/app/src/main/java/org/mian/gitnex/helpers/Version.java
@@ -50,7 +50,7 @@ public class Version {
 		final Pattern pattern_number_dot_number = Pattern.compile("^\\d+(\\.(\\d)+)*");
 
 		if(!valid(raw)) {
-			throw new IllegalArgumentException("Invalid version format");
+			throw new IllegalArgumentException("Invalid version format: " + raw);
 		}
 
 		if(raw.charAt(0) == 'v' || raw.charAt(0) == 'V') {
diff --git a/app/src/main/java/org/mian/gitnex/helpers/views/SyntaxHighlightedArea.java b/app/src/main/java/org/mian/gitnex/helpers/views/SyntaxHighlightedArea.java
index f7a65575..ff3c0e9b 100644
--- a/app/src/main/java/org/mian/gitnex/helpers/views/SyntaxHighlightedArea.java
+++ b/app/src/main/java/org/mian/gitnex/helpers/views/SyntaxHighlightedArea.java
@@ -1,5 +1,6 @@
 package org.mian.gitnex.helpers.views;
 
+import android.app.Activity;
 import android.content.Context;
 import android.graphics.Canvas;
 import android.graphics.Paint;
@@ -36,19 +37,16 @@ public class SyntaxHighlightedArea extends LinearLayout {
 	private LinesView linesView;
 
 	public SyntaxHighlightedArea(@NonNull Context context) {
-
 		super(context);
 		setup();
 	}
 
 	public SyntaxHighlightedArea(@NonNull Context context, @Nullable AttributeSet attrs) {
-
 		super(context, attrs);
 		setup();
 	}
 
 	public SyntaxHighlightedArea(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
-
 		super(context, attrs, defStyleAttr);
 		setup();
 	}
@@ -62,9 +60,10 @@ public class SyntaxHighlightedArea extends LinearLayout {
 		sourceView = new TextView(getContext());
 
 		sourceView.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT));
-		sourceView.setTextSize(TypedValue.COMPLEX_UNIT_SP, 14);
 		sourceView.setTypeface(Typeface.createFromAsset(getContext().getAssets(), "fonts/sourcecodeproregular.ttf"));
+		sourceView.setTextSize(TypedValue.COMPLEX_UNIT_SP, 14);
 		sourceView.setTextColor(prism4jTheme.textColor());
+		sourceView.setTextIsSelectable(true);
 
 		int padding = AppUtil.getPixelsFromDensity(getContext(), 5);
 		sourceView.setPadding(padding, 0, padding, 0);
@@ -97,34 +96,57 @@ public class SyntaxHighlightedArea extends LinearLayout {
 	public void setContent(@NonNull String source, @NonNull String extension) {
 
 		if(source.length() > 0) {
-			linesView.setLineCount(AppUtil.getLineCount(source));
 
-			try {
+			Thread highlightingThread = new Thread(() -> {
 
-				MainGrammarLocator mainGrammarLocator = MainGrammarLocator.getInstance();
-				Prism4j prism4j = new Prism4j(mainGrammarLocator);
+				try {
 
-				CharSequence highlightedSource = Prism4jSyntaxHighlight.create(prism4j, prism4jTheme, MainGrammarLocator.DEFAULT_FALLBACK_LANGUAGE)
-					.highlight(mainGrammarLocator.fromExtension(extension), source);
+					MainGrammarLocator mainGrammarLocator = MainGrammarLocator.getInstance();
 
-				if(highlightedSource.charAt(highlightedSource.length() - 1) == '\n') {
-					// Removes a line break which is probably added by Prism4j but not actually present in the source.
-					// This line should be altered in case this gets fixed.
-					sourceView.setText(highlightedSource.subSequence(0, highlightedSource.length() - 1));
-				}
-				else {
-					sourceView.setText(highlightedSource);
+					CharSequence highlightedSource = Prism4jSyntaxHighlight
+						.create(new Prism4j(mainGrammarLocator), prism4jTheme, MainGrammarLocator.DEFAULT_FALLBACK_LANGUAGE)
+						.highlight(mainGrammarLocator.fromExtension(extension), source);
+
+					getActivity().runOnUiThread(() -> {
+						if(highlightedSource.charAt(highlightedSource.length() - 1) == '\n') {
+							// Removes a line break which is probably added by Prism4j but not actually present in the source.
+							// This line should be altered in case this gets fixed.
+							sourceView.setText(highlightedSource.subSequence(0, highlightedSource.length() - 1));
+						} else {
+							sourceView.setText(highlightedSource);
+						}
+					});
+
+				} catch(Throwable ignored) {
+					// Fall back to plaintext if something fails
+					getActivity().runOnUiThread(() -> sourceView.setText(source));
 				}
 
-			} catch(Throwable ignored) {
-				// Fall back to plaintext if something fails
-				sourceView.setText(source);
-			}
+			});
+
+			Thread lineCountingThread = new Thread(() -> {
+
+				long lineCount = AppUtil.getLineCount(source);
+
+				try {
+					highlightingThread.join();
+				} catch(InterruptedException ignored) {}
+
+				getActivity().runOnUiThread(() -> linesView.setLineCount(lineCount));
+
+			});
+
+			highlightingThread.start();
+			lineCountingThread.start();
+
 		}
 	}
 
-    public String getContent() {
+	private Activity getActivity() {
+		return (Activity) getContext();
+	}
 
+    public String getContent() {
 		return sourceView.getText().toString();
     }
 
@@ -137,27 +159,31 @@ public class SyntaxHighlightedArea extends LinearLayout {
 		@ColorInt private int textColor;
 		@ColorInt private int lineColor;
 
-		private int lineCount;
+		private long lineCount;
 
 	    public LinesView(Context context) {
 	    	super(context);
 	    }
 
-		public void setLineCount(int lineCount) {
+		public void setLineCount(long lineCount) {
 			this.lineCount = lineCount;
+			requestLayout();
 		}
 
 		@Override
 		public void setBackgroundColor(@ColorInt int backgroundColor) {
 			this.backgroundColor = backgroundColor;
+			invalidate();
 		}
 
 		public void setTextColor(@ColorInt int textColor) {
 			this.textColor = textColor;
+			invalidate();
 		}
 
 		public void setLineColor(@ColorInt int lineColor) {
 			this.lineColor = lineColor;
+			invalidate();
 		}
 
 		public Paint getPaint() {
diff --git a/app/src/main/java/org/mian/gitnex/notifications/Notifications.java b/app/src/main/java/org/mian/gitnex/notifications/Notifications.java
index 68cb399c..cf03e691 100644
--- a/app/src/main/java/org/mian/gitnex/notifications/Notifications.java
+++ b/app/src/main/java/org/mian/gitnex/notifications/Notifications.java
@@ -13,7 +13,6 @@ import androidx.work.WorkManager;
 import org.mian.gitnex.R;
 import org.mian.gitnex.helpers.Constants;
 import org.mian.gitnex.helpers.TinyDB;
-import org.mian.gitnex.helpers.Version;
 import java.util.concurrent.TimeUnit;
 
 /**
@@ -22,8 +21,6 @@ import java.util.concurrent.TimeUnit;
 
 public class Notifications {
 
-	private static int notificationsSupported = -1;
-
 	public static int uniqueNotificationId(Context context) {
 
 		TinyDB tinyDB = TinyDB.getInstance(context);
@@ -51,7 +48,7 @@ public class Notifications {
 			mainChannel.setDescription(context.getString(R.string.mainNotificationChannelDescription));
 
 			if(tinyDB.getBoolean("notificationsEnableVibration", true)) {
-				mainChannel.setVibrationPattern(new long[] { 1000, 1000 });
+				mainChannel.setVibrationPattern(Constants.defaultVibrationPattern);
 				mainChannel.enableVibration(true);
 			} else {
 				mainChannel.enableVibration(false);
@@ -75,7 +72,7 @@ public class Notifications {
 
 	public static void stopWorker(Context context) {
 
-		WorkManager.getInstance(context).cancelAllWorkByTag(context.getPackageName());
+		WorkManager.getInstance(context).cancelAllWorkByTag(Constants.notificationsWorkerId);
 	}
 
 	public static void startWorker(Context context) {
@@ -84,42 +81,25 @@ public class Notifications {
 
 		if(tinyDB.getBoolean("notificationsEnabled", true)) {
 
-			if(notificationsSupported == -1) checkVersion(tinyDB);
-
-			if(notificationsSupported == 1) {
-
-				Constraints.Builder constraints = new Constraints.Builder()
-					.setRequiredNetworkType(NetworkType.CONNECTED)
-					.setRequiresBatteryNotLow(false)
-					.setRequiresStorageNotLow(false)
-					.setRequiresCharging(false);
-
-				if(android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
-
-					constraints.setRequiresDeviceIdle(false);
-				}
-
-				int pollingDelayMinutes = Math.max(tinyDB.getInt("pollingDelayMinutes", Constants.defaultPollingDelay), 15);
-
-				PeriodicWorkRequest periodicWorkRequest = new PeriodicWorkRequest.Builder(NotificationsWorker.class, pollingDelayMinutes, TimeUnit.MINUTES)
-					.setConstraints(constraints.build())
-					.addTag(context.getPackageName())
-					.build();
-
-				WorkManager.getInstance(context).enqueueUniquePeriodicWork(context.getPackageName(), ExistingPeriodicWorkPolicy.KEEP, periodicWorkRequest);
+			Constraints.Builder constraints = new Constraints.Builder()
+				.setRequiredNetworkType(NetworkType.CONNECTED)
+				.setRequiresBatteryNotLow(false)
+				.setRequiresStorageNotLow(false)
+				.setRequiresCharging(false);
 
+			if(android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
+				constraints.setRequiresDeviceIdle(false);
 			}
+
+			int pollingDelayMinutes = Math.max(tinyDB.getInt("pollingDelayMinutes", Constants.defaultPollingDelay), 15);
+
+			PeriodicWorkRequest periodicWorkRequest = new PeriodicWorkRequest.Builder(NotificationsWorker.class, pollingDelayMinutes, TimeUnit.MINUTES)
+				.setConstraints(constraints.build())
+				.addTag(Constants.notificationsWorkerId)
+				.build();
+
+			WorkManager.getInstance(context).enqueueUniquePeriodicWork(Constants.notificationsWorkerId, ExistingPeriodicWorkPolicy.KEEP, periodicWorkRequest);
+
 		}
 	}
-
-	private static void checkVersion(TinyDB tinyDB) {
-
-		String currentVersion = tinyDB.getString("giteaVersion");
-
-		if(tinyDB.getBoolean("loggedInMode") && !currentVersion.isEmpty()) {
-
-			notificationsSupported = new Version(currentVersion).higherOrEqual("1.12.3") ? 1 : 0;
-		}
-	}
-
 }
